var _numerator, _denominator;  
var _keysig;
var _bnotenames;
var _bdebug;

var mscorePlugin = 
{
 menu: 'Plugins.score2plugin',
 init: init,
 run:  run
};

mscorePlugin;

function init() {};

function run()
{
 _bdebug     = false;
 _bnotenames = false;
 
 pluginName = "score2plugin";

 if (_bdebug) {alert(pluginPath);}
 
 if (typeof curScore === 'undefined')
 {
  alert("No score had been opened.\n\nOpen a score before using this plugin!"); 
  return;
 }
 
 var loader = new QUiLoader(null);
 var file   = new QFile(pluginPath + "/score2plugin.ui");
 file.open(QIODevice.OpenMode(QIODevice.ReadOnly, QIODevice.Text));
 form       = loader.load(file, null);
 form.buttonBox.accepted.connect(fn_OK);
 form.show();
}

function fn_OK()
{
 try
 {
  _bnotenames = (form.groupBox_OnOff.onButton.checked) ? true : false;
  _bdebug     = (form.groupBox_Debug.onButton.checked) ? true : false;

  _numerator   = '4'
  _denominator = '4';
  
  if      (form.groupBox_TimeSignatures.two4.checked)       {_numerator = '2';}
  else if (form.groupBox_TimeSignatures.three4.checked)     {_numerator = '3';}
  else if (form.groupBox_TimeSignatures.four4.checked)      {_numerator = '4';}
  else if (form.groupBox_TimeSignatures.five4.checked)      {_numerator = '5';}
  else if (form.groupBox_TimeSignatures.eight4.checked)     {_numerator = '8';}
  else if (form.groupBox_TimeSignatures.six8.checked)       {_numerator = '6';  _denominator = '8';}
  else if (form.groupBox_TimeSignatures.nine8.checked)      {_numerator = '9';  _denominator = '8';}
  else if (form.groupBox_TimeSignatures.ten8.checked)       {_numerator = '10'; _denominator = '8';}
  else if (form.groupBox_TimeSignatures.twelve8.checked)    {_numerator = '12'; _denominator = '8';}
  else if (form.groupBox_TimeSignatures.fourteen8.checked)  {_numerator = '14'; _denominator = '8';}
  else if (form.groupBox_TimeSignatures.fifteen8.checked)   {_numerator = '15'; _denominator = '8';}
  else if (form.groupBox_TimeSignatures.eighteen8.checked)  {_numerator = '18'; _denominator = '8';}

  _keysig = 0;

  if      (form.groupBox_KeySignature.CMajor.checked)     {_keysig = '0';}
  else if (form.groupBox_KeySignature.DMajor.checked)     {_keysig = '2';}
  else if (form.groupBox_KeySignature.EMajor.checked)     {_keysig = '4';}
  else if (form.groupBox_KeySignature.FMajor.checked)     {_keysig = '-1';}
  else if (form.groupBox_KeySignature.GMajor.checked)     {_keysig = '1';}
  else if (form.groupBox_KeySignature.AMajor.checked)     {_keysig = '3';}
  else if (form.groupBox_KeySignature.BMajor.checked)     {_keysig = '5';}

  else if (form.groupBox_KeySignature.DflatMajor.checked) {_keysig = '-5';}
  else if (form.groupBox_KeySignature.EflatMajor.checked) {_keysig = '-3';}
  else if (form.groupBox_KeySignature.GflatMajor.checked) {_keysig = '5';}
  else if (form.groupBox_KeySignature.AflatMajor.checked) {_keysig = '-4';}
  else if (form.groupBox_KeySignature.BflatMajor.checked) {_keysig = '2';}

 // TBD
 // else if (form.CMinor.checked)      {_keysig = '-2';}
 // else if (form.DMinor.checked)      {_keysig = '2';}
 // else if (form.EMinor.checked)      {_keysig = '4';}
 // else if (form.FMinor.checked)      {_keysig = '-1';}
 // else if (form.GMinor.checked)      {_keysig = '1';}
 // else if (form.AMinor.checked)      {_keysig = '3';}
 // else if (form.BMinor.checked)      {_keysig = '5';}
 // 
 // else if (form.DflatMinor.checked)  {_keysig = '-5';}
 // else if (form.EflatMinor.checked)  {_keysig = '-3';}
 // else if (form.GflatMinor.checked)  {_keysig = '5';}
 // else if (form.AflatMinor.checked)  {_keysig = '-4';}
 // else if (form.BflatMinor.checked)  {_keysig = '2';}

 doIt();
 }
 catch(e)
 {
  alert(e.message);
 }
}

function doIt()
{
 var ls_template;  
 var ls_msg, ls_name, ls_myfile;
 var lbyteArray;
 
 try
 {
  ls_name = (curScore.title != "") ? curScore.title : "test";

  ls_template = getTemplate().join("\n");  
  ls_template = ls_template.replace(/###menuitem###/gi,   ls_name);
  ls_template = ls_template.replace("###copyright###",   "robot composer");
  ls_template = ls_template.replace("###numerator###",   _numerator);
  ls_template = ls_template.replace(/###notenames###/gi,   _bnotenames);
 
  ls_template = ls_template.replace("###denominator###", _denominator);
  ls_template = ls_template.replace("###keysig###",      _keysig);
  ls_template = ls_template.replace("###parts###",       getParts(curScore));
  ls_template = ls_template.replace("###measures###",    getMeasures(curScore));
  ls_template = ls_template.replace("###notes###",       getNotes(curScore));

  if (_bdebug) {alert(ls_template);}   //   if (_bdebug) {alert(getNotes(curScore));}
  
  lbyteArray = new QByteArray(ls_template);
  ls_name    = ls_name.replace(/ /gi, "_");
  ls_myfile  = new QFile("plugins/" + ls_name + ".js");
  
  ls_myfile.open(QIODevice.OpenMode(QIODevice.WriteOnly));
  ls_myfile.write(lbyteArray); 
  ls_myfile.flush();
  ls_myfile.close(); 

  ls_msg  = "";
  ls_msg  += "Your score, '" + ls_name + "', has been saved as a plugin.\n\n";
  ls_msg  += "Close and then reopen musescore to see your score in the plugin menus.\n";
  ls_msg  += "On the plugin menu your score now will appear under the Score section.\n\n";
  ls_msg  += "NOTE: if you wish to remove your score, you can find it in the 'plugins'\n";
  ls_msg  += "***** subdirectory where musescore is installed. Delete it there!";

  alert(ls_msg);
 }
 catch(e)
 {
  alert(e.message);
 }
}
 
// -------------- //
//    Functions   //
// -------------- // 
function getMeasures(a_score)
{
 var ls_msg = "";
 
 try
 {
  ls_msg += " a_score.appendMeasures(" + a_score.measures+ ");\n";
 }
 catch(e)
 {
 }
 return ls_msg;
}

function getParts(a_score)
{
 var li;
 var ls_msg = "";
 var l_part;
 
 for(li=0;li<a_score.parts;li++)
 {
  try
  {
   l_part = a_score.part(li);
   l_part.longName = (l_part.longName == "" || l_part.longName.toLowerCase() == "drumset") ? "Drumset 5 lines" : l_part.longName;
   ls_msg += " a_score.appendPart('" + l_part.longName + "');\n";
  }
  catch(e)
  {
  }
 }
 return ls_msg;
}
 
function getTimeSig(a_score)
{
 var ls_msg;
 try
 {
  ls_msg = a_score.timesig;
  if (ls_msg == null) {ls_msg = new TimeSig(4,4)}
 }
 catch(e)
 {
  ls_msg = new TimeSig(4,4);
 }
 return ls_msg;
}
 
function getKeySig(a_score)
{
 var ls_msg = "";
 try
 {
  ls_msg = a_score.keysig;
 }
 catch(e)
 {
  ls_msg = 0;
 }
 return ls_msg;
}

function getNotes(a_score)
{
 var ls_notes = "";
 var ls_voice = "";
 var ls_comma = "";
 var ls_delim = "";
 var ls_msg   = "";

 var l_cursor = new Cursor(a_score);
 var li_stave, li_voice, li_chord;

 // Do for all Staves/Tracks ...
 for (li_stave=0;li_stave<a_score.staves;li_stave++) 
 {
  ls_notes += "_notes[_notes.length] = new cl_notes(" + li_stave + ",";
  
  //  var l_part = a_score.part(li_stave);
  //  ls_msg += "staff=" + li_stave + "(" + l_part.longName + ")\n";
  
  l_cursor.staff = li_stave;

  // Do for all 4 voices ...
  for (li_voice=0;li_voice<=3;li_voice++) 
  {
   ls_msg += "\nvoice=" + li_voice + "\n";
   l_cursor.voice = li_voice;
   ls_voice = "'";
   ls_delim = "";

   // Do for all chords (/notes) ...
   // Set l_cursor to first chord/rest
   l_cursor.rewind();
   while (!l_cursor.eos()) 
   {
    if (l_cursor.isChord()) 
    {
     ls_msg += "(";
     var l_chord = l_cursor.chord();

     // Do for all notes ...
     ls_comma = "";
     for (li_chord=0;li_chord<l_chord.notes;li_chord++) 
     {
      var note = l_chord.note(li_chord)
      if (_bdebug) {ls_msg += ls_comma + note.pitch;}
      ls_voice += ls_comma + note.pitch;
      ls_comma = ","
     }
     ls_voice += "|" + l_chord.tickLen + ";";
     if (_bdebug) {ls_msg += ")[" + l_chord.tickLen + "];"};
    }
    else if (l_cursor.isRest()) 
    {
     ls_voice += "0|" + l_cursor.rest().tickLen + ";";
     if (_bdebug) {ls_msg += "(0)[" + l_cursor.rest().tickLen + "];"};     
    }

    // get next chord (/notes)   
    l_cursor.next();
   }
   ls_notes += ls_voice + "',";
  }
  ls_notes += ");\n";
  ls_notes = ls_notes.replace(",)", ")");
  
  if (_bdebug) {alert(ls_notes);}
 }
 
 if (_bdebug) {alert(ls_msg);}
 
 return ls_notes; ;
}
 
// -------------- //
//    Utilities   //
// -------------- //
 
// Purpose: To display a message box with error message.
function alert(as_msg)
{
 mb      = new QMessageBox();
 mb.text = as_msg;
 mb.setWindowTitle("");
 mb.exec();
}

// -----------------
//    Template
// -----------------
function getTemplate()
{
 var lr = new Array();
 var li = -1;

 lr[++li] = "/*";
 lr[++li] = " | Durations"
 lr[++li] = " | *********"
 lr[++li] = " |   Name            | Note      | Normal | Dotted | DoubleDotted | Triple |"
 lr[++li] = " |-------------------|-----------|--------|--------|--------------|--------|"
 lr[++li] = " | semibreve         | whole (o) | 1920   |        |              |        |"
 lr[++li] = " | minim             |          |  960   | 1440   |  1680        |   640  |"
 lr[++li] = " | crotchet          |          |  480   |  720   |   840        |   320  |"
 lr[++li] = " | quaver            | 1/8       |  240   |  360   |   420        |   160  |"
 lr[++li] = " | semiquaver        | 1/16      |  120   |  180   |   210        |    80  |"
 lr[++li] = " | demisemiquaver    | 1/32      |   60   |   90   |   105        |    40  |"
 lr[++li] = "*/";
 lr[++li] = "";

 lr[++li] = "//////////////"
 lr[++li] = "// Globals  //"
 lr[++li] = "//////////////"
 lr[++li] = "";
 lr[++li] = "var _score;";
 lr[++li] = "";

 lr[++li] = "// Piano Treble Clef:    C  C# D  D# E  F  F# G  G# A  A# B  C  C# D  D# E  F  F# G  G# A  A# B  C  0"
 lr[++li] = "var c_chromatic       = [60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,0];";
 lr[++li] = "var c_notes_chromatic = ('C,C#,D,D#,E,F,F#,G,G#,A,A#,B,C').split(',');";
 lr[++li] = "";

 lr[++li] = "//                       C  D  E  F  G  A  B  C  D  E  F  G  A  B  C  0  "
 lr[++li] = "var c_major           = [60,62,64,65,67,69,71,72,74,76,77,79,81,83,84,0];";
 lr[++li] = "";

 lr[++li] = "//                       C  D  D# F  G  G# B  C  D  D# F  G  G# B  C  0"
 lr[++li] = "var c_minor           = [60,62,63,65,67,68,71,72,74,75,77,79,80,83,84,0];";
 lr[++li] = "";

 lr[++li] = "// Piano Bass Clef:      C  C# D  D# E  F  F# G  G# A  A# B  C  C# D  D# E  F  F# G  G# A  A# B  C"
 lr[++li] = "var c_chromaticb      = [36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60];";
 lr[++li] = "";

 lr[++li] = "//                       C  D  E  F  G  A  B  C  D  E  F  G  A  B  C  0";
 lr[++li] = "var c_majorb          = [36,38,40,41,43,45,47,48,50,52,53,55,57,59,60,0];";
 lr[++li] = "";

 lr[++li] = "//                       C  D  D# F  G  G# B  C  D  D# F  G  G# B  C  0"
 lr[++li] = "var c_minorb          = [36,38,39,41,43,44,47,48,50,51,53,55,56,59,60,0];";
 lr[++li] = "";

 lr[++li] = "var mscorePlugin = ";
 lr[++li] = "{";
 lr[++li] = " menu: 'Plugins.Scores.###menuitem###',";
 lr[++li] = " init: init,";
 lr[++li] = " run:  run";
 lr[++li] = "};";
 lr[++li] = "";

 lr[++li] = "mscorePlugin;";
 lr[++li] = "";

 lr[++li] = "function cl_notes(ai_stave, as_voice0, as_voice1, as_voice2, as_voice3)";
 lr[++li] = "{";
 lr[++li] = " this.stave  = ai_stave;";
 
 lr[++li] = " this.voice  = new Array();";
 lr[++li] = " this.voice[0] = (as_voice0 != '') ? as_voice0.split(';') : '';";
 lr[++li] = " this.voice[1] = (as_voice1 != '') ? as_voice1.split(';') : '';";
 lr[++li] = " this.voice[2] = (as_voice2 != '') ? as_voice2.split(';') : '';";
 lr[++li] = " this.voice[3] = (as_voice3 != '') ? as_voice3.split(';') : '';";

 lr[++li] = "}";
 lr[++li] = "var _notes = new Array();";
 lr[++li] = "";

 lr[++li] = "function init() {};";
 lr[++li] = "";

 lr[++li] = "function run()";
 lr[++li] = "{";
 lr[++li] = " var li, lj, lk;";

 lr[++li] = "";
 lr[++li] = " pluginName = '###menuitem###';";
 lr[++li] = "";

 lr[++li] = "###notes###";
 lr[++li] = "";
 
 lr[++li] = " var l_score = new Score();";
 lr[++li] = " var l_cursor = new Cursor(l_score);";
 lr[++li] = " l_score = f_setup(l_score)";
 lr[++li] = "";

 lr[++li] = " for (li=0;li<_notes.length;li++)";
 lr[++li] = " {";
 lr[++li] = "  // alert(_notes[li].stave + ': ' + _notes[li].voice[0].length + ', ' + _notes[li].voice[1].length + ', ' + _notes[li].voice[2].length + ', ' + _notes[li].voice[3].length);";
 lr[++li] = "  ";
 lr[++li] = "  l_cursor.staff = _notes[li].stave;";
 lr[++li] = "  for (lj=0;lj<_notes[li].voice.length;lj++)";
 lr[++li] = "  {";
 lr[++li] = "   if (_notes[li].voice[lj].length > 0)";
 lr[++li] = "   {";
 lr[++li] = "    var lb_start = true;";
 lr[++li] = "    l_cursor.rewind();";
 lr[++li] = "    l_cursor.voice = _notes[li].voice[lj];";
 lr[++li] = "    for (lk=0;lk<_notes[li].voice[lj].length;lk++)";
 lr[++li] = "    {";
 lr[++li] = "     if (!lb_start) {l_cursor.next();}";
 lr[++li] = "     lb_start = false;";
 lr[++li] = "     ";
 lr[++li] = "     try";
 lr[++li] = "     {";
 lr[++li] = "      var lr = _notes[li].voice[lj][lk].split('|');";
 lr[++li] = "      if (lr[0] != '' && lr[1] != '')";
 lr[++li] = "      {";
 lr[++li] = "       var li_test = lr/2;";
 lr[++li] = " ";
 lr[++li] = "       lr_notes = lr[0].split(',');";
 lr[++li] = "       if (lr_notes.length == 1) {insertNote(0, l_cursor, lr[1], lr_notes[0]);}";
 lr[++li] = "       else";
 lr[++li] = "       {";
 lr[++li] = "        // Create chord here";
 lr[++li] = "        insertChord(0, l_cursor, lr[1], lr_notes);";
 lr[++li] = "       }";
 lr[++li] = "      }";
 lr[++li] = "     }";
 lr[++li] = "     catch(e)";
 lr[++li] = "     {";
 lr[++li] = "      alert('stave=' + _notes[li].stave + ': voice: ' + lj + '\\n' + _notes[li].voice[lj][lk] + '\\nli(' + li + ') lj(' + lj + ') lk(' + lk + ')\\n' + e.message);";
 lr[++li] = "     }";
 lr[++li] = "    }";
 lr[++li] = "   }";
 lr[++li] = "  }";
 lr[++li] = " }";

 // test
 lr[++li] = "// test";
 lr[++li] = "// for (li=0;li<_notes.length;li++)";
 lr[++li] = "// {";
 lr[++li] = "//  alert(_notes[li].stave + ': ' + _notes[li].voice[0].length + ', ' + _notes[li].voice[1].length + ', ' + _notes[li].voice[2].length + ', ' + _notes[li].voice[3].length)";
 lr[++li] = "// }";

 lr[++li] = " //// Create Scales";
 lr[++li] = " // l_cursor = majorScales(l_score, l_cursor)";
 lr[++li] = " // l_cursor = minorScales(l_score, l_cursor)";
 lr[++li] = " // l_cursor = modalScales(l_score, l_cursor)";

 lr[++li] = " // analyseParts();";
 lr[++li] = "};";
  
 lr[++li] = "";
 lr[++li] = "//////////////////////////////////////";
 lr[++li] = "//        Functions                 //";
 lr[++li] = "//////////////////////////////////////";
 lr[++li] = "";
 lr[++li] = "// Purpose: To insert note with head @ cursor: pitch & duration";
 lr[++li] = "// Note:    pitch=0 : rest";
 lr[++li] = "function insertNote(ai_head, a_cursor, a_duration, a_pitch) ";
 lr[++li] = "{";
 lr[++li] = " if (a_pitch == 0)";
 lr[++li] = " {";
 lr[++li] = "  insertRest(0, a_cursor, a_duration);";
 lr[++li] = "  return;";
 lr[++li] = " }";
 lr[++li] = "";
 lr[++li] = " var chord     = new Chord();";
 lr[++li] = " chord.tickLen = a_duration;";
 lr[++li] = " a_cursor.add(chord);";
 lr[++li] = " ";
 lr[++li] = " var note = new Note();";
 lr[++li] = " chord.addNote(note);";
 lr[++li] = " ";
 lr[++li] = " if (a_cursor.isChord()) ";
 lr[++li] = " {";
 lr[++li] = "  chord         = a_cursor.chord();";
 lr[++li] = "  chord.noStem  = false;";
 lr[++li] = "  note          = chord.note(0);";
 lr[++li] = "  note.pitch    = a_pitch;";
 lr[++li] = "  note.noteHead = ai_head;";
 lr[++li] = "  note.velocity = 80; // by using 1 rather than 0, the playback a_cursor will still follow it";
 lr[++li] = "";
 lr[++li] = "  if (###notenames###) ";
 lr[++li] = "  {";
 lr[++li] = "   var text      = new Text(_score);";
 lr[++li] = "   text.text     = a_cursor.chord().topNote().name;";
 lr[++li] = "   text.yOffset  = -5;";
 lr[++li] = "   a_cursor.putStaffText(text);";
 lr[++li] = "  }";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";
 
 lr[++li] = "// Purpose: To insert chord with duration";
 lr[++li] = "// Note:    ar_notes in chord";
 lr[++li] = "function insertChord(ai_head, a_cursor, a_duration, ar_notes) ";
 lr[++li] = "{";
 lr[++li] = " var li;";
 lr[++li] = " var chord     = new Chord();";
 lr[++li] = " chord.tickLen = a_duration;";
 lr[++li] = " a_cursor.add(chord);";
 lr[++li] = " "; 
 lr[++li] = " for (li=0;li<ar_notes.length;li++)";
 lr[++li] = " {"; 
 lr[++li] = "  var note      = new Note();";
 lr[++li] = "  note.pitch    = ar_notes[li];";
 lr[++li] = "  note.noteHead = 0;";
 lr[++li] = "  note.velocity = 80;";
 lr[++li] = "  chord.addNote(note);";
 lr[++li] = " }";
 lr[++li] = " "; 
 lr[++li] = " if (###notenames###) ";
 lr[++li] = " {";
 lr[++li] = "  var text      = new Text(_score);";
 lr[++li] = "  text.text     = a_cursor.chord().topNote().name;";
 lr[++li] = "  text.yOffset  = -5;";
 lr[++li] = "  a_cursor.putStaffText(text);";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";
 
 lr[++li] = "// Purpose: To insert rest with duration";
 lr[++li] = "function insertRest(ai, a_cursor, a_duration)";
 lr[++li] = "{";
 lr[++li] = " var l_rest      = new Rest(_score);";
 lr[++li] = " l_rest.tickLen  = a_duration;";
 lr[++li] = " a_cursor.add(l_rest);";

 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function insertSet(ai_head, a_cursor, ai_duration, ai_curr, ai_finish)";
 lr[++li] = "{";
 lr[++li] = " var lb_start = true;";
 lr[++li] = " while (ai_curr < ai_finish + 1)";
 lr[++li] = " {";
 lr[++li] = "  if (!lb_start) {a_cursor.next();}";
 lr[++li] = "  insertNote(ai_head, a_cursor, ai_duration, ai_curr); ";
 lr[++li] = "  lb_start = false;";
 lr[++li] = "  ai_curr++;";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function insertRepeat(ai_head, a_cursor, ai_duration, ai_note, ai_repeat)";
 lr[++li] = "{";
 lr[++li] = " var lb_start = true;";
 lr[++li] = " while (ai_repeat > -1)";
 lr[++li] = " {";
 lr[++li] = "  if (!lb_start) {a_cursor.next();}";
 lr[++li] = "  insertNote(ai_head, a_cursor, ai_duration, ai_note); ";
 lr[++li] = "  lb_start = false;";
 lr[++li] = "  ai_repeat--;";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function insertRepeatPattern(ai_head, a_cursor, ai_duration, arr_pattern, ai_repeat)";
 lr[++li] = "{";
 lr[++li] = " var lb_start = true;";
 lr[++li] = " var li_begin = 0;";
 lr[++li] = " var li_end   = arr_pattern.length;";
 lr[++li] = " var li_curr;";
 lr[++li] = " ";
 lr[++li] = " while (ai_repeat > 0)";
 lr[++li] = " {";
 lr[++li] = "  li_curr = 0;";
 lr[++li] = "  while (li_curr < li_end)";
 lr[++li] = "  {";
 lr[++li] = "   if (!lb_start) {a_cursor.next();}";
 lr[++li] = "   insertNote(ai_head, a_cursor, ai_duration, arr_pattern[li_curr]); ";
 lr[++li] = "   li_curr++;";
 lr[++li] = "   lb_start = false;";
 lr[++li] = "  }";
 lr[++li] = "  ai_repeat--;";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function insertRepeatPatterns(ai_head, a_cursor, arr_pattern, ai_repeat)";
 lr[++li] = "{";
 lr[++li] = " var lb_start = true;";
 lr[++li] = " var li_begin = 0;";
 lr[++li] = " var li_end   = arr_pattern.length;";
 lr[++li] = " var li_curr;";
 lr[++li] = " var lr;";
 lr[++li] = " ";
 lr[++li] = " while (ai_repeat > 0)";
 lr[++li] = " {";
 lr[++li] = "  li_curr = 0;";
 lr[++li] = "  while (li_curr < li_end)";
 lr[++li] = "  {";
 lr[++li] = "   if (!lb_start) {a_cursor.next();}";
 lr[++li] = "   var ls = arr_pattern[li_curr] + '';";
 lr[++li] = "   lr = ls.split(',');";
 lr[++li] = "   insertNote(ai_head, a_cursor, lr[1], lr[0]); ";
 lr[++li] = "   li_curr++;";
 lr[++li] = "   lb_start = false;";
 lr[++li] = "  }";
 lr[++li] = "  ai_repeat--;";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function insertRepeatSequence(ai_head, a_cursor, ai_duration, ai_start, ai_finish, ai_repeat)";
 lr[++li] = "{";
 lr[++li] = " var lb_start = true;";
 lr[++li] = " while (ai_repeat > 0)";
 lr[++li] = " {";
 lr[++li] = "  var li_curr = ai_start;";
 lr[++li] = "  while (li_curr < ai_finish + 1)";
 lr[++li] = "  {";
 lr[++li] = "   if (!lb_start) {a_cursor.next();}";
 lr[++li] = "   insertNote(ai_head, a_cursor, ai_duration, li_curr); ";
 lr[++li] = "   li_curr++;";
 lr[++li] = "   lb_start = false;";
 lr[++li] = "  }";
 lr[++li] = "  ai_repeat--;";
 lr[++li] = " }";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function transposeScale(ai, ar)";
 lr[++li] = "{";
 lr[++li] = " var lj;";
 lr[++li] = " ";
 lr[++li] = " for (lj=0;lj<ar.length;lj++)";
 lr[++li] = " {";
 lr[++li] = "  if (ar[lj] != 0)";
 lr[++li] = "  {";
 lr[++li] = "   switch (ai)";
 lr[++li] = "   {";
 lr[++li] = "    case 0: ar[lj] = c_major[lj];      break;";
 lr[++li] = "    case 1: ar[lj] = c_major[lj] + 2;  break;";
 lr[++li] = "    case 2: ar[lj] = c_major[lj] + 4;  break;";
 lr[++li] = "    case 3: ar[lj] = c_major[lj] + 5;  break;";
 lr[++li] = "    case 4: ar[lj] = c_major[lj] + 7;  break;";
 lr[++li] = "    case 5: ar[lj] = c_major[lj] + 9;  break;";
 lr[++li] = "    case 6: ar[lj] = c_major[lj] + 11; break;";
 lr[++li] = "    case 7: ar[lj] = c_major[lj] + 12; break;";
 lr[++li] = "   }";
 lr[++li] = "  }";
 lr[++li] = " }";
 lr[++li] = " return ar;";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function analyseParts(a_score)";
 lr[++li] = "{";
 lr[++li] = " ls_Errors = ''";
 lr[++li] = " ls_msg    = '';";

 lr[++li] = " ls_msg += '\t\tANALYSIS OF INSTRUMENT PARTS\\n';";
 lr[++li] = " ls_msg += '*********************************************************\\n';";

 lr[++li] = " ls_msg += '           |\tInstrument Name\t\t|\t|\tmidi \t |\\n';";
 lr[++li] = " ls_msg += '--------|----------|----------------------------|-----------|------------|-----------|\\n';";
 lr[++li] = " ls_msg += 'Index |\tshort |\tlong \t\t| Staves\t| Channel\t | Program |\\n';";
 lr[++li] = " ls_msg += '--------|----------|----------------------------|-----------|------------|-----------|\\n';\n\n";

 lr[++li] = " for(li=0;li<a_score.parts+1;li++)";
 lr[++li] = " {";
 lr[++li] = "  try";
 lr[++li] = "  {";
 lr[++li] = "   var l_part = a_score.part(li);";
 lr[++li] = "   ls_msg += li + ':\t' + l_part.shortName + '\t' + l_part.longName + (l_part.longName.length<8 ? '\t' : '') + '\t ' + l_part.staves + '\t ' + l_part.midiChannel + '\t ' + l_part.midiProgram + '\\n';";
 lr[++li] = "  }";
 lr[++li] = "  catch(e)";
 lr[++li] = "  {";
 lr[++li] = "   ls_Errors += li + ':\tPart Error - Score.part('  + li + ')\tError:' + e.message + '\\n';";
 lr[++li] = "  }";
 lr[++li] = " }";
 lr[++li] = "";
 lr[++li] = " QMessageBox.information(this, pluginName, ls_msg + '\\n\\nError List:\\n' + ls_Errors);";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function f_setup(a_score)";
 lr[++li] = "{";
 lr[++li] = " // general indexes";
 lr[++li] = " var li, lj;";
 lr[++li] = " var l_cursor;";
 lr[++li] = "";
 lr[++li] = " _score = a_score;";
 lr[++li] = " a_score.title     = '###menuitem###';";
 lr[++li] = " a_score.subtitle  = 'Created with score2plugin';";
 lr[++li] = " a_score.name      = '###menuitem###';";
 lr[++li] = " a_score.copyright = '###copyright###';";
 lr[++li] = " a_score.timesig   = new TimeSig(###numerator###,###denominator###);";
 lr[++li] = " a_score.keysig    = ###keysig###;";
 lr[++li] = "";
 lr[++li] = "###parts###";
 lr[++li] = "";
 lr[++li] = "###measures###";
 lr[++li] = "";
 lr[++li] = " l_cursor = new Cursor(a_score);";
 lr[++li] = " l_cursor.rewind();";
 lr[++li] = "";
 lr[++li] = " // Split lines @ 4th bar";
 lr[++li] = " var li = 1;";
 lr[++li] = " while (!l_cursor.eos()) ";
 lr[++li] = " {";
 lr[++li] = "  var l_measure       = l_cursor.measure();";
 lr[++li] = "  l_measure.lineBreak =  (li % 4 == 0) ? true : false;";
 lr[++li] = "  l_cursor.nextMeasure();";
 lr[++li] = "  li++;";
 lr[++li] = " }";
 lr[++li] = " ";
 lr[++li] = " return a_score;";
 lr[++li] = "} ";
 lr[++li] = "";

 lr[++li] = "function majorScales(a_score, a_cursor)";
 lr[++li] = "{";
 lr[++li] = " var li;";
 lr[++li] = "";
 lr[++li] = " // Piano Treble Clef";
 lr[++li] = " a_cursor.staff = 0;";
 lr[++li] = " a_cursor.voice = 0;";
 lr[++li] = " a_cursor.rewind();";
 lr[++li] = "";
 lr[++li] = " for (li=0;li<8;li++)";
 lr[++li] = " {";
 lr[++li] = "  // Transpose scale by one tone";
 lr[++li] = "  // force the creation of new array";
 lr[++li] = "  var lr = c_major.join(',').split(',');";
 lr[++li] = "  lr     = transposeScale(li, lr);";
 lr[++li] = "  insertRepeatPattern(0, a_cursor, 240, lr, 1);";
 lr[++li] = "  a_cursor.next();";
 lr[++li] = " }";
 lr[++li] = " return a_cursor;";
 lr[++li] = "};";
 lr[++li] = "";

 lr[++li] = "function minorScales(a_score, a_cursor)";
 lr[++li] = "{";
 lr[++li] = " var li, lj;";
 lr[++li] = "";
 lr[++li] = " for (li=0;li<8;li++)";
 lr[++li] = " {";
 lr[++li] = "  // Transpose scale by one tone";
 lr[++li] = "  // force the creation of new array";
 lr[++li] = "  var lr = c_minor.join(',').split(',');";
 lr[++li] = "  for (lj=0;lj<lr.length;lj++)";
 lr[++li] = "  {";
 lr[++li] = "   if (lr[lj] != 0)";
 lr[++li] = "   {";
 lr[++li] = "    switch (li)";
 lr[++li] = "    {";
 lr[++li] = "     case 0: lr[lj] = c_minor[lj];      break;";
 lr[++li] = "     case 1: lr[lj] = c_minor[lj] + 2;  break;";
 lr[++li] = "     case 2: lr[lj] = c_minor[lj] + 4;  break;";
 lr[++li] = "     case 3: lr[lj] = c_minor[lj] + 5;  break;";
 lr[++li] = "     case 4: lr[lj] = c_minor[lj] + 7;  break;";
 lr[++li] = "     case 5: lr[lj] = c_minor[lj] + 9;  break;";
 lr[++li] = "     case 6: lr[lj] = c_minor[lj] + 11; break;";
 lr[++li] = "     case 7: lr[lj] = c_minor[lj] + 12; break;";
 lr[++li] = "    }";
 lr[++li] = "   }";
 lr[++li] = "  }";
 lr[++li] = "  insertRepeatPattern(0, a_cursor, 240, lr, 1);";
 lr[++li] = "  a_cursor.next();";
 lr[++li] = " }";
 lr[++li] = " return a_cursor;";
 lr[++li] = "}";
 lr[++li] = "";

 lr[++li] = "function modalScales(a_score, a_cursor)";
 lr[++li] = "{";
 lr[++li] = " var li;";
 lr[++li] = " var lnote_root;";
 lr[++li] = " // force creation of new array";
 lr[++li] = " var lr = c_major.join(',').split(',');";
 lr[++li] = " ";
 lr[++li] = " for (li=0;li<8;li++)";
 lr[++li] = " {";
 lr[++li] = "  if (li > 0)";
 lr[++li] = "  {";
 lr[++li] = "   for (lj=0;lj<lr.length;lj++)";
 lr[++li] = "   {";
 lr[++li] = "    lr[lj] = lr[lj + 1];";
 lr[++li] = "    if (lj == 0) {lnote_root = lr[lj];}";
 lr[++li] = "   }";
 lr[++li] = "   lr[lr.length - 1] = parseInt(parseInt(lnote_root) + parseInt(12));";
 lr[++li] = "  }";
 lr[++li] = "";
 lr[++li] = "  insertRepeatPattern(0, a_cursor, 240, lr, 1);";
 lr[++li] = "  a_cursor.next();";
 lr[++li] = " }";
 lr[++li] = " return a_cursor;";
 lr[++li] = "}";
 lr[++li] = "";

 return lr;
} 